/*
 * Copyright (c) 2006-2008, Kyosuke Takayama <support@mc.neweb.ne.jp>
 * It is released under the MIT LICENSE.
*/

if(typeof Shingles == 'undefined')
   var Shingles = {};

Shingles.prefManager = {

   initPrefs: function() {
      var io = Shingles.IO.init();
      var $  = this.$;

      var size = io.getChar('options.size');
      if (!size) size = 6;
      $('options.size').value = size;
      var sizeVerify = io.getChar('options.sizeVerify');
      if (!sizeVerify) sizeVerify = 4;
      $('options.sizeVerify').value = sizeVerify;
      var limitLoad = parseInt(io.getChar('options.limitLoad'));
      if (!limitLoad) limitLoad = 1;
      if (limitLoad > 5 || limitLoad < 1) limitLoad = 1;
      $('options.limitLoad').value = limitLoad;
      var nRandom = io.getChar('options.nRandom');
      if (!nRandom) nRandom = 3;
      $('options.nRandom').value = nRandom;
	  var procentToAdd = io.getChar('options.procentToAdd');
	  if (!procentToAdd) procentToAdd = 3;
      $('options.procentToAdd').value = procentToAdd;
	  var procentToStop = io.getChar('options.procentToStop');
	  if (!procentToStop) procentToStop = 99;
      $('options.procentToStop').value = procentToStop;

	  var timeout = io.getChar('options.timeout');
	  if (!timeout) timeout = 5;
      $('options.timeout').value = timeout;

      var yandexReq = io.getChar('options.yandexReq');
      if (!yandexReq) yandexReq = 'http://yandex.ru/yandsearch?text="%s"';
      var googleReq = io.getChar('options.googleReq');
      if (!googleReq) googleReq = 'http://www.google.com/search?ie=UTF-8&num=10&hl=en&q="%s"';

      $('options.yandexReq').value = yandexReq;
      $('options.googleReq').value = googleReq;

   },

   setPrefs: function() {
      var io = Shingles.IO.init();
      var $  = this.$;

      io.setChar('options.size', $('options.size').value);
      io.setChar('options.sizeVerify', $('options.sizeVerify').value);
      io.setChar('options.nRandom', $('options.nRandom').value);
      io.setChar('options.procentToAdd', $('options.procentToAdd').value);
      io.setChar('options.procentToStop', $('options.procentToStop').value);
      io.setChar('options.yandexReq', $('options.yandexReq').value);
      io.setChar('options.googleReq', $('options.googleReq').value);
      io.setChar('options.timeout', $('options.timeout').value);
      io.setChar('options.limitLoad', $('options.limitLoad').value);

      var win= Components.classes["@mozilla.org/appshell/window-mediator;1"].
         getService(Components.interfaces.nsIWindowMediator).getEnumerator("navigator:browser");

      while(win.hasMoreElements()) {
         var browser = win.getNext();
         browser.Shingles.addon.update();
      }
   },

   $: function(e) {
      return document.getElementById(e);
   }
}
