var objLogg = {
	nContextMenuLeft: null,
	nContextMenuTop: null,
	ndContextMenuNode: null,

	objDate: null,
	objDBService: null,
	objDBFile: null,
	objDBConnect: null,
	objStringBundle: null,
	bLocked: false,

	objPrefs: Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch('extensions.Logg.'),

	Init: function(e) {
		window.removeEventListener('load', objLogg.Init, false);

		if (!getBrowser || !getBrowser().browsers) return true;
		var ndBrowser = getBrowser();

		window.addEventListener('unload', objLogg.Destroy, false);
		window.addEventListener('close', objLogg.Destroy, true);

		ndBrowser.addEventListener('contextmenu', objLogg.ContextMenu, true);

		objLogg.objMediator = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);

		objLogg.objDBService = Components.classes['@mozilla.org/storage/service;1'].getService(Components.interfaces.mozIStorageService);
		objLogg.objDBFile = Components.classes['@mozilla.org/file/directory_service;1'].getService(Components.interfaces.nsIProperties).get('ProfD', Components.interfaces.nsIFile);

		objLogg.objDBFile.append('Logg_v1.sqlite');

		objLogg.objDBConnect = objLogg.objDBService.openDatabase(objLogg.objDBFile);
		objLogg.objDBConnect.executeSimpleSQL('CREATE TABLE IF NOT EXISTS logg_log (type TEXT, url TEXT, url2 TEXT, text TEXT, time INTEGER, ip TEXT)');

		objLogg.BeginTransaction(objLogg.objDBConnect.TRANSACTION_EXCLUSIVE);

		objLogg.objSelectLog = objLogg.objDBConnect.createStatement('SELECT * FROM logg_log WHERE rowid = ?1');
		objLogg.objSelectLogList = objLogg.objDBConnect.createStatement('SELECT type, url, url2, text, ip, time FROM logg_log WHERE 1');
		objLogg.objDeleteLog = objLogg.objDBConnect.createStatement('DELETE FROM logg_log WHERE rowid = ?1');
		objLogg.objInsertLog = objLogg.objDBConnect.createStatement('INSERT INTO logg_log VALUES (?1, ?2, ?3, ?4, ?5, ?6)');
		objLogg.objUpdateLog = objLogg.objDBConnect.createStatement('UPDATE logg_log SET type = ?2, url = ?3, url2 = ?4, text = ?5, time = ?6, ip = ?7 WHERE rowid = ?1');
		objLogg.objTruncateLog = objLogg.objDBConnect.createStatement('DELETE FROM logg_log');

		objLogg.objSelectCount = objLogg.objDBConnect.createStatement('SELECT COUNT(*) FROM logg_log');
		objLogg.objSelectSidebarRow = objLogg.objDBConnect.createStatement('SELECT type, url, url2, text, ip, time, rowid FROM logg_log WHERE 1 ORDER BY time LIMIT ?1, 1');

		objLogg.Commit();

		return true;
	},

	GetRow: function(nRow)
	{
		var objData = null;
		var objLogg = this;

		try
		{
			objLogg.BeginTransaction();
			objLogg.objSelectSidebarRow.bindInt32Parameter(0, nRow);
			if (objLogg.objSelectSidebarRow.executeStep())
			{
				objData = {};


				var objDate = new Date();
				objDate.setTime(objLogg.objSelectSidebarRow.getInt64(5));
				objData['view-tree-time'] = objDate.getPHPDate('j.m.Y, G:i');
				objData['view-tree-ip'] = objLogg.objSelectSidebarRow.getUTF8String(4);
				objData['view-tree-type'] = objLogg.objSelectSidebarRow.getUTF8String(0);
				objData['view-tree-text'] = objLogg.objSelectSidebarRow.getUTF8String(3);
				objData['view-tree-url'] = objLogg.objSelectSidebarRow.getUTF8String(1);
				objData['view-tree-url2'] = objLogg.objSelectSidebarRow.getUTF8String(2);

			}
		}
		finally
		{
			if (objLogg && objLogg.objSelectSidebarRow && objLogg.objSelectSidebarRow && objLogg.objSelectSidebarRow.reset) objLogg.objSelectSidebarRow.reset();
		}

		return objData ? objData : '';
	},

	Destroy: function(e)
	{
		if (objLogg.objDBService) objLogg.Commit();

		var ndBrowser = getBrowser();

		window.removeEventListener('unload', objLogg.Destroy, false);
		window.removeEventListener('close', objLogg.Destroy, true);

		ndBrowser.removeEventListener('contextmenu', objLogg.ContextMenu, true);

		return true;
	},

	GetLockedWindow: function()
	{
		var objWindows = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator).getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();
			if (objWindow.objLogg && objWindow.objLogg.bLocked) return objWindow;
		}

		return false;
	},

	UnlockWindows: function()
	{
		var objWindows = objLogg.objMediator.getEnumerator('navigator:browser');
		while (objWindows.hasMoreElements())
		{
			var objWindow = objWindows.getNext();
			if (objWindow.objLogg) objWindow.objLogg.bLocked = false;
		}

		return true;
	},

	BeginTransaction: function()
	{
		if (objLogg.bLocked) return true;

		objLogg.Commit();
		objLogg.bLocked = true;

		var nType = arguments.length ? arguments[0] : objLogg.objDBConnect.TRANSACTION_DEFERRED;
		objLogg.objDBConnect.beginTransactionAs(nType);

		return true;
	},

	Commit: function()
	{
		var objWindow = objLogg.GetLockedWindow();
		if (!objWindow && objLogg.objDBConnect.transactionInProgress) objLogg.objDBConnect.commitTransaction();
		if (objWindow && objWindow.objLogg.objDBConnect.transactionInProgress) objWindow.objLogg.objDBConnect.commitTransaction();

		objLogg.UnlockWindows();
		return true;
	},

	GetParentNodes: function(ndNode)
	{
		var aParents = [];
		while (ndNode.nodeName.toLowerCase() != '#document')
		{
			aParents.push(ndNode);
			ndNode = ndNode.parentNode;
		}

		return aParents;
	},

	IsParent: function(ndNode, aCandidates)
	{
		var objParents = {};
		while (ndNode.nodeName.toLowerCase() != '#document')
		{
			objParents[ndNode.nodeName.toLowerCase()] = true;
			ndNode = ndNode.parentNode;
		}

		for (var nCandidate = 0; aCandidates[nCandidate] !== undefined; ++nCandidate)
		{
			if (objParents[aCandidates[nCandidate]]) return true;
		}

		return false;
	},

	ViewLog: function()
	{
		window.openDialog('chrome://Shingles/content/logg_view_log.xul', 'shinglesViewLog', 'centerscreen,chrome,modal');

		return true;
	},

	clearLog: function()
	{
		if (this.objDBService) {
			this.BeginTransaction();
			this.objTruncateLog.execute();
		}

		return true;
	},

	urlBar_insert: function(url, time, ip) {
		if (this.objDBService) {
			this.BeginTransaction();
			//type TEXT, url TEXT, url2 TEXT, text TEXT, time INTEGER, ip INTEGER
			this.objInsertLog.bindUTF8StringParameter(0, '=URL=');
			this.objInsertLog.bindUTF8StringParameter(1, url);
			this.objInsertLog.bindUTF8StringParameter(2, '');
			this.objInsertLog.bindUTF8StringParameter(3, '');
			this.objInsertLog.bindInt64Parameter(4, time);
			this.objInsertLog.bindUTF8StringParameter(5, ip);
			this.objInsertLog.execute();
		}
	},

	menuSite_insert: function(url, time, ip) {
		if (this.objDBService) {
			this.BeginTransaction();
			//type TEXT, url TEXT, url2 TEXT, text TEXT, time INTEGER, ip INTEGER
			this.objInsertLog.bindUTF8StringParameter(0, '=SITE=');
			this.objInsertLog.bindUTF8StringParameter(1, url);
			this.objInsertLog.bindUTF8StringParameter(2, '');
			this.objInsertLog.bindUTF8StringParameter(3, '');
			this.objInsertLog.bindInt64Parameter(4, time);
			this.objInsertLog.bindUTF8StringParameter(5, ip);
			this.objInsertLog.execute();
		}
	},

	menuSiteText_insert: function(url, text, time, ip) {
		if (this.objDBService) {
			this.BeginTransaction();
			//type TEXT, url TEXT, url2 TEXT, text TEXT, time INTEGER, ip INTEGER
			this.objInsertLog.bindUTF8StringParameter(0, '=TEXT=');
			this.objInsertLog.bindUTF8StringParameter(1, url);
			this.objInsertLog.bindUTF8StringParameter(2, '');
			this.objInsertLog.bindUTF8StringParameter(3, text);
			this.objInsertLog.bindInt64Parameter(4, time);
			this.objInsertLog.bindUTF8StringParameter(5, ip);
			this.objInsertLog.execute();
		}
	},

	linkClick_insert: function(urlFrom, urlTo, text, time, ip) {
		if (this.objDBService) {
			this.BeginTransaction();
			//type TEXT, url TEXT, url2 TEXT, text TEXT, time INTEGER, ip INTEGER
			this.objInsertLog.bindUTF8StringParameter(0, '=CLICK=');
			this.objInsertLog.bindUTF8StringParameter(1, urlTo);
			this.objInsertLog.bindUTF8StringParameter(2, urlFrom);
			this.objInsertLog.bindUTF8StringParameter(3, text);
			this.objInsertLog.bindInt64Parameter(4, time);
			this.objInsertLog.bindUTF8StringParameter(5, ip);
			this.objInsertLog.execute();
		}
	},

	ContextMenu: function(e)
	{
		var ndNode = e.explicitOriginalTarget || e.originalTarget;
		if (ndNode.nodeName.match(/^xul/)) return true;
		if (objLogg.IsParent(ndNode, ['input', 'textarea', 'select'])) return true;

		objLogg.ndContextMenuNode = ndNode;
		objLogg.ndContextMenuMarkNode = null;
		objLogg.nContextMenuLeft = e.pageX;
		objLogg.nContextMenuTop = e.pageY;

		var ndDocument = objLogg.ndContextMenuNode.ownerDocument;
		var ndBody = ndDocument.body;
		if (!ndBody) return true;

		//!!!del if (!ndBody.getAttribute('logg_next')) objLogg.Clear(objLogg.ndContextMenuNode);

		return true;
	}
};

if (!Array.prototype.indexOf)
{
	Array.prototype.indexOf = function(objFind)
	{
		var nLength = this.length;

		var nOffset = Number(arguments[1]) || 0;
		nOffset = (nOffset < 0) ? Math.ceil(nOffset) : Math.floor(nOffset);
		if (nOffset < 0) nOffset += nLength;

		while (nOffset < nLength)
		{
			if ((nOffset in this) && (this[nOffset] === objFind)) return nOffset;
			++nOffset;
		}

		return -1;
	};
}

if (!Array.prototype.indexOf)
{
	Array.prototype.indexOf = function()
	{
		if (arguments.length != 1) return false;

		for (var nIndex = 0; this[nIndex]; ++nIndex)
		{
			if (this[nIndex] == arguments[0]) return nIndex;
		}

		return false;
	};
}

window.addEventListener('load', objLogg.Init, false);
